'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.offsetToPosition = offsetToPosition;
exports.locToRange = locToRange;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Range = exports.Range = function () {
  function Range(start, end) {
    _classCallCheck(this, Range);

    this.start = start;
    this.end = end;
  }

  Range.prototype.containsPosition = function containsPosition(position) {
    var withinLine = this.start.line <= position.line && this.end.line >= position.line;
    var withinCharacter = this.start.character <= position.character && this.end.character >= position.character;
    return withinLine && withinCharacter;
  };

  return Range;
}(); /**
      *  Copyright (c) Facebook, Inc.
      *  All rights reserved.
      *
      *  This source code is licensed under the license found in the
      *  LICENSE file in the root directory of this source tree.
      *
      *  
      */

var Position = exports.Position = function () {
  function Position(line, character) {
    _classCallCheck(this, Position);

    this.line = line;
    this.character = character;
  }

  Position.prototype.lessThanOrEqualTo = function lessThanOrEqualTo(position) {
    if (this.line < position.line || this.line === position.line && this.character <= position.character) {
      return true;
    }

    return false;
  };

  return Position;
}();

function offsetToPosition(text, loc) {
  var EOL = '\n';
  var buf = text.slice(0, loc);
  var lines = buf.split(EOL).length - 1;
  var lastLineIndex = buf.lastIndexOf(EOL);
  return new Position(lines, loc - lastLineIndex - 1);
}

function locToRange(text, loc) {
  var start = offsetToPosition(text, loc.start);
  var end = offsetToPosition(text, loc.end);
  return new Range(start, end);
}